package org.infinispan.tx;

import org.infinispan.config.Configuration;
import org.infinispan.manager.DefaultCacheManager;
import org.infinispan.manager.EmbeddedCacheManager;
import org.infinispan.test.SingleCacheManagerTest;
import org.infinispan.tree.Fqn;
import org.infinispan.tree.TreeCache;
import org.infinispan.tree.TreeCacheFactory;
import org.testng.annotations.Test;

@Test(testName = "tx.SimpleTxTest", groups = "functional")
public class JBossStandaloneJTAManagerLookupTxTest extends SingleCacheManagerTest {

	TreeCache<String, String> treeCache;

	@Override
	protected EmbeddedCacheManager createCacheManager() throws Exception {
		Configuration c = new Configuration();
		c.setTransactionManagerLookupClass("org.infinispan.transaction.lookup.JBossStandaloneJTAManagerLookup"); //fails
		//c.setTransactionManagerLookupClass("org.infinispan.transaction.lookup.DummyTransactionManagerLookup"); //passes
		c.setInvocationBatchingEnabled(true);
		c.setUseLazyDeserialization(true);

		EmbeddedCacheManager ecm = new DefaultCacheManager(c);
		TreeCacheFactory treeCacheFactory = new TreeCacheFactory();
		treeCache = treeCacheFactory.createTreeCache(ecm.<String, String>getCache());
		return ecm;
	}

	public void doTest() {
		treeCache.put(Fqn.fromElements("a", "b"), "k", "v");
		assert "v".equals(treeCache.get(Fqn.fromElements("a", "b"), "k"));
	}
}
